blame.c: Properly initialize strbuf after calling, textconv_object()
[git/dscho.git] / git-sh-setup.sh
blob6131670860514c215a6b9b7417dd05c3124e81b4
1 #!/bin/sh
3 # This is included in commands that either have to be run from the toplevel
4 # of the repository, or with GIT_DIR environment variable properly.
5 # If the GIT_DIR does not look like the right correct git-repository,
6 # it dies.
8 # Having this variable in your environment would break scripts because
9 # you would cause "cd" to be taken to unexpected places. If you
10 # like CDPATH, define it for your interactive shell sessions without
11 # exporting it.
12 unset CDPATH
14 git_broken_path_fix () {
15 case ":$PATH:" in
16 *:$1:*) : ok ;;
18 PATH=$(
19 SANE_TOOL_PATH="$1"
20 IFS=: path= sep=
21 set x $PATH
22 shift
23 for elem
25 case "$SANE_TOOL_PATH:$elem" in
26 (?*:/bin | ?*:/usr/bin)
27 path="$path$sep$SANE_TOOL_PATH"
28 sep=:
29 SANE_TOOL_PATH=
30 esac
31 path="$path$sep$elem"
32 sep=:
33 done
34 echo "$path"
37 esac
40 # @@BROKEN_PATH_FIX@@
42 die() {
43 echo >&2 "$@"
44 exit 1
47 GIT_QUIET=
49 say () {
50 if test -z "$GIT_QUIET"
51 then
52 printf '%s\n' "$*"
56 if test -n "$OPTIONS_SPEC"; then
57 usage() {
58 "$0" -h
59 exit 1
62 parseopt_extra=
63 [ -n "$OPTIONS_KEEPDASHDASH" ] &&
64 parseopt_extra="--keep-dashdash"
66 eval "$(
67 echo "$OPTIONS_SPEC" |
68 git rev-parse --parseopt $parseopt_extra -- "$@" ||
69 echo exit $?
71 else
72 dashless=$(basename "$0" | sed -e 's/-/ /')
73 usage() {
74 die "Usage: $dashless $USAGE"
77 if [ -z "$LONG_USAGE" ]
78 then
79 LONG_USAGE="Usage: $dashless $USAGE"
80 else
81 LONG_USAGE="Usage: $dashless $USAGE
83 $LONG_USAGE"
86 case "$1" in
87 -h|--h|--he|--hel|--help)
88 echo "$LONG_USAGE"
89 exit
90 esac
93 set_reflog_action() {
94 if [ -z "${GIT_REFLOG_ACTION:+set}" ]
95 then
96 GIT_REFLOG_ACTION="$*"
97 export GIT_REFLOG_ACTION
101 git_editor() {
102 if test -z "${GIT_EDITOR:+set}"
103 then
104 GIT_EDITOR="$(git var GIT_EDITOR)" || return $?
107 eval "$GIT_EDITOR" '"$@"'
110 git_pager() {
111 if test -t 1
112 then
113 GIT_PAGER=$(git var GIT_PAGER)
114 else
115 GIT_PAGER=cat
117 : ${LESS=-FRSX}
118 export LESS
120 eval "$GIT_PAGER" '"$@"'
123 sane_grep () {
124 GREP_OPTIONS= LC_ALL=C grep "$@"
127 sane_egrep () {
128 GREP_OPTIONS= LC_ALL=C egrep "$@"
131 is_bare_repository () {
132 git rev-parse --is-bare-repository
135 cd_to_toplevel () {
136 cdup=$(git rev-parse --show-toplevel) &&
137 cd "$cdup" || {
138 echo >&2 "Cannot chdir to $cdup, the toplevel of the working tree"
139 exit 1
143 require_work_tree () {
144 test "$(git rev-parse --is-inside-work-tree 2>/dev/null)" = true ||
145 die "fatal: $0 cannot be used without a working tree."
148 get_author_ident_from_commit () {
149 pick_author_script='
150 /^author /{
151 s/'\''/'\''\\'\'\''/g
153 s/^author \([^<]*\) <[^>]*> .*$/\1/
154 s/'\''/'\''\'\'\''/g
155 s/.*/GIT_AUTHOR_NAME='\''&'\''/p
158 s/^author [^<]* <\([^>]*\)> .*$/\1/
159 s/'\''/'\''\'\'\''/g
160 s/.*/GIT_AUTHOR_EMAIL='\''&'\''/p
163 s/^author [^<]* <[^>]*> \(.*\)$/\1/
164 s/'\''/'\''\'\'\''/g
165 s/.*/GIT_AUTHOR_DATE='\''&'\''/p
170 encoding=$(git config i18n.commitencoding || echo UTF-8)
171 git show -s --pretty=raw --encoding="$encoding" "$1" -- |
172 LANG=C LC_ALL=C sed -ne "$pick_author_script"
175 # Clear repo-local GIT_* environment variables. Useful when switching to
176 # another repository (e.g. when entering a submodule). See also the env
177 # list in git_connect()
178 clear_local_git_env() {
179 unset $(git rev-parse --local-env-vars)
182 # Make sure we are in a valid repository of a vintage we understand,
183 # if we require to be in a git repository.
184 if test -z "$NONGIT_OK"
185 then
186 GIT_DIR=$(git rev-parse --git-dir) || exit
187 if [ -z "$SUBDIRECTORY_OK" ]
188 then
189 test -z "$(git rev-parse --show-cdup)" || {
190 exit=$?
191 echo >&2 "You need to run this command from the toplevel of the working tree."
192 exit $exit
195 test -n "$GIT_DIR" && GIT_DIR=$(cd "$GIT_DIR" && pwd) || {
196 echo >&2 "Unable to determine absolute path of git directory"
197 exit 1
199 : ${GIT_OBJECT_DIRECTORY="$GIT_DIR/objects"}
202 # Fix some commands on Windows
203 case $(uname -s) in
204 *MINGW*)
205 # Windows has its own (incompatible) sort and find
206 sort () {
207 /usr/bin/sort "$@"
209 find () {
210 /usr/bin/find "$@"
213 esac